From 39d83cce7f682f1542d3e866ce0f6843fd995eab Mon Sep 17 00:00:00 2001
From: Stephanie Buser <sbuser@codeaurora.org>
Date: Thu, 22 Apr 2021 17:46:01 +0530
Subject: [PATCH 04/15] Adding Support for BQ25895

---
 ql-ol-kernel/arch/arm64/boot/dts/qcom/rg500q-evk.dtsi | 17 +++++++++++++++++
 ql-ol-kernel/drivers/power/supply/Kconfig             |  1 +
 ql-ol-kernel/drivers/power/supply/bq25890_charger.c   | 12 +++++++-----
 3 files changed, 25 insertions(+), 5 deletions(-)

diff --git a/ql-ol-kernel/arch/arm64/boot/dts/qcom/rg500q-evk.dtsi b/ql-ol-kernel/arch/arm64/boot/dts/qcom/rg500q-evk.dtsi
index 06ed191..a98479b 100755
--- a/ql-ol-kernel/arch/arm64/boot/dts/qcom/rg500q-evk.dtsi
+++ b/ql-ol-kernel/arch/arm64/boot/dts/qcom/rg500q-evk.dtsi
@@ -35,4 +35,21 @@
 		reg = <0x55>;
 		monitored-battery = <&bat>;
 	};
+
+	bq25890@6a {
+		compatible = "ti,bq25890";
+		reg = <0x6a>;
+
+		ti,battery-regulation-voltage = <4200000>;
+		ti,charge-current = <1000000>;
+		ti,termination-current = <50000>;
+		ti,precharge-current = <128000>;
+		ti,minimum-sys-voltage = <3600000>;
+		ti,boost-voltage = <5000000>;
+		ti,boost-max-current = <1000000>;
+
+		ti,use-ilim-pin;
+		ti,thermal-regulation-threshold = <120>;
+	};
+
 };
diff --git a/ql-ol-kernel/drivers/power/supply/Kconfig b/ql-ol-kernel/drivers/power/supply/Kconfig
index f5cb64b..2f31956 100755
--- a/ql-ol-kernel/drivers/power/supply/Kconfig
+++ b/ql-ol-kernel/drivers/power/supply/Kconfig
@@ -547,6 +547,7 @@ config CHARGER_BQ25890
 	tristate "TI BQ25890 battery charger driver"
 	depends on I2C
 	depends on GPIOLIB || COMPILE_TEST
+	default y
 	select REGMAP_I2C
 	help
 	  Say Y to enable support for the TI BQ25890 battery charger.
diff --git a/ql-ol-kernel/drivers/power/supply/bq25890_charger.c b/ql-ol-kernel/drivers/power/supply/bq25890_charger.c
index 8e2c41d..95d6425 100755
--- a/ql-ol-kernel/drivers/power/supply/bq25890_charger.c
+++ b/ql-ol-kernel/drivers/power/supply/bq25890_charger.c
@@ -30,8 +30,10 @@
 
 #define BQ25890_MANUFACTURER		"Texas Instruments"
 #define BQ25890_IRQ_PIN			"bq25890_irq"
+#define BQ25890_INTR_ENABLE             0
 
 #define BQ25890_ID			3
+#define BQ25895_ID			7
 
 enum bq25890_fields {
 	F_EN_HIZ, F_EN_ILIM, F_IILIM,				     /* Reg00 */
@@ -840,7 +842,7 @@ static int bq25890_probe(struct i2c_client *client,
 		return bq->chip_id;
 	}
 
-	if (bq->chip_id != BQ25890_ID) {
+	if ((bq->chip_id != BQ25890_ID) && (bq->chip_id != BQ25895_ID)){
 		dev_err(dev, "Chip with ID=%d, not supported!\n", bq->chip_id);
 		return -ENODEV;
 	}
@@ -860,7 +862,7 @@ static int bq25890_probe(struct i2c_client *client,
 		dev_err(dev, "Cannot initialize the chip.\n");
 		return ret;
 	}
-
+#if BQ25890_INTR_ENABLE
 	if (client->irq <= 0)
 		client->irq = bq25890_irq_probe(bq);
 
@@ -868,7 +870,7 @@ static int bq25890_probe(struct i2c_client *client,
 		dev_err(dev, "No irq resource found.\n");
 		return client->irq;
 	}
-
+#endif
 	/* OTG reporting */
 	bq->usb_phy = devm_usb_get_phy(dev, USB_PHY_TYPE_USB2);
 	if (!IS_ERR_OR_NULL(bq->usb_phy)) {
@@ -876,14 +878,14 @@ static int bq25890_probe(struct i2c_client *client,
 		bq->usb_nb.notifier_call = bq25890_usb_notifier;
 		usb_register_notifier(bq->usb_phy, &bq->usb_nb);
 	}
-
+#if BQ25890_INTR_ENABLE
 	ret = devm_request_threaded_irq(dev, client->irq, NULL,
 					bq25890_irq_handler_thread,
 					IRQF_TRIGGER_FALLING | IRQF_ONESHOT,
 					BQ25890_IRQ_PIN, bq);
 	if (ret)
 		goto irq_fail;
-
+#endif
 	ret = bq25890_power_supply_init(bq);
 	if (ret < 0) {
 		dev_err(dev, "Failed to register power supply\n");
-- 
2.7.4

